#version 120
// (C) 2010 Dmytry Lavrov. All rights reserved.
uniform float brightness;
uniform float t;
varying vec3 delta;

const float color_phase=0.0;

const float pi=3.141592;

vec3 AmpColor(float t_){
	const float o=pi*2.0/3.0;
	float t=color_phase+t_;
	return pow(vec3(cos(t+o*2.0)*0.5+0.5, cos(t+o)*0.5+0.5, cos(t)*0.5+0.5),vec3(8.0))+vec3(0.25,0.25,0.25);
}

void main(void)
{
	float phase=30.0*sin(t*0.005);
	float alpha=t*0.1;

	vec2 cs1=vec2(cos(alpha), sin(alpha));

	vec3 rpos=vec3(gl_Vertex.x*cs1.x+gl_Vertex.z*cs1.y, gl_Vertex.y, gl_Vertex.z*cs1.x-gl_Vertex.x*cs1.y);
	//vec3 rpos=gl_Vertex.xyz;

	float r=length(rpos.xy)+0.01;
	vec2 base = rpos.xy*(1.0/r);

	float u=mod(rpos.z*3.0*sin(t*0.01)+phase*(0.95+0.05*(abs(rpos.x)+abs(rpos.y))), 1.0);

	float spin_phase=3.0*pow(1.0-u,3.0);
	//float spin_phase=0;

  vec2 cs=vec2(cos(phase+spin_phase),-sin(phase+spin_phase));

  vec2 rbase=vec2(base.x*cs.x+base.y*cs.y, base.y*cs.x-base.x*cs.y);

  vec3 vert=vec3(rbase*u*u*3.0, 5.0-1.0/(u+0.1))*r;


  vec4 camera_pos = gl_ModelViewMatrixInverse[3];
	vec4 pos = gl_ModelViewProjectionMatrix * vec4(vert, 1.0);

	delta=(gl_ModelViewMatrix * vec4(vert, 1.0)).xyz;

	//float br=dot(normalize(gl_Vertex-camera_pos).xyz,vel);
	float br=clamp(u*(1-u)-0.05, 0.0, 1.0);
	//float br=0.1;

	float l=dot(delta,delta);
	gl_Position=pos;
	//float q=exp2(255.0*gl_Color.a-119.0);
	//vec3 col=gl_Color.rgb*(q*sqrt(brightness)*br);
	vec3 col=AmpColor(u*u*30.0+t*3.0)*(sqrt(brightness)*br*20.0);
	gl_FrontColor=vec4(col,1.0);
}
