if not main_loaded then
require("main")
end

LogMessage("+love")

local startpos={0,0,0}
local pos={0,0,0}
local scale=6.0;
local pts_density=5.0;

if not PtTransform then
	function PtTransform(p)
		return p
	end
end

if not VTransform then
	function VTransform(p)
		return p
	end
end

local font={
	[" "]={
		delta=2,
		lines={}
	},
	["I"]={
		delta=0,
		lines={0,0,  0,4, 1}
	},
	["L"]={
	delta=2,
	lines={0,0,  0,4, 1,
				2,0,  0,0, 1}
	},
	["O"]={
	delta=2,
	lines=
		{
			1,0,  0,2, 0,
			0,2,  1,4, 0,
			1,4,	2,2, 0,
			2,2,  1,0, 0,
		}
	},
	["V"]={
		delta=4,
		lines={
			0,4,  2,0, 0,
			2,0,  4,4, 1,
		}
	},
	["E"]={
		delta=2,
		lines={
		0,4,  0,0, 1,
		2,4,  0,4, 0,
		2,2,  0,2, 0,
		2,0,  0,0, 0,
		}
	},

	["Y"]={
		delta=2,
		lines={
		0,4,  1,2, 0,
		1,2,  2,4, 1,
		1,0,  1,2, 0,
		}
	},

	["U"]={
		delta=3,
		lines={
		0,4,  0,1, 0,
		0,1,  1,0, 0,
		1,0,  2,0, 0,
		2,0,  3,1, 0,
		3,1,  3,4, 1,
		}
	},

	["S"]={
		delta=3,
		lines={
		3,4,  1,4, 0,
		1,4,  0,3, 0,
		0,3,  1,2, 0,
		1,2,  2,2, 0,
		2,2,  3,1, 0,
		3,1,  2,0, 0,
		2,0,  0,0, 1,
		}
	},


	["A"]={
		delta=4,
		lines={
		0,0,  2,4, 0,
		2,4,  4,0, 1,
		1,2,  3,2, 1,
		}
	},

	["R"]={
		delta=3,
		lines={
		0,0,  0,4, 0,
		0,4,  2,4, 0,
		2,4,  3,3, 0,
		3,3,  2,2, 0,
		2,2,  0,2, 0,
		3,0,  2,2, 0,
		}
	},

}
message_points={}

function DrawPoint(p)
	message_points[#message_points+1]={p[1]*scale+pos[1],p[2]*scale+pos[2]}
end

function DrawLine(p1,p2)
	local delta=SubVec(p2,p1)
	local l=Len(delta)
	local npts=math.ceil(l*pts_density)
	for i=0, npts-1 do
		DrawPoint(AddVec(p1,ScaleVec(delta,i/npts)))
	end
end

function DrawLines(lines)
	for i=1, #lines-1, 5 do
			DrawLine({lines[i],lines[i+1]},{lines[i+2],lines[i+3]})
			if lines[i+4] then
				DrawPoint({lines[i+2],lines[i+3]})
			end
		end
end

function DrawChar(c)
	LogMessage("DrawChar ".. c)
	local a=font[c]
	if a then
		if a.lines then
			DrawLines(a.lines)
		end
		pos[1]=pos[1]+(a.delta+0.5)*scale
	end
end

function DrawString(s)
	for i=1,s:len() do
		DrawChar(s:sub(i,i))
	end
end

function StringWidth(s)
	local result=0
	for i=1,s:len() do
		local c=s:sub(i,i)
		result=result+font[c].delta*scale
	end
	if s:len()>1 then
		result=result+0.5*(s:len()-1)*scale
	end
	return result
end


pos[1]=startpos[1]
pos[2]=startpos[2]
pos[3]=startpos[3]

pos[1]=startpos[1]-0.5*StringWidth("SARA")
DrawString("SARA")
pos[1]=startpos[1]-0.5*StringWidth("I LOVE")
pos[2]=pos[2]-5.5*scale
DrawString("I LOVE")
pos[1]=startpos[1]-0.5*StringWidth("YOU")
pos[2]=pos[2]-5.5*scale
DrawString("YOU")
local text_width=StringWidth("I LOVE")

--heart
local pi=3.141592
local cx=0
local cy=-8
pos[1]=0
pos[2]=0
pos[3]=0
for a=0, pi, pi/(40*pts_density) do
	local x=math.sin(a)*15
	local y=math.cos(a)*15+x*1.3
	DrawPoint({cx+x,cy+y})
	DrawPoint({cx-x,cy+y})
end


function Script:SpawnSnowflakesSpecial()
	local target_height=-200
	local arrival_time=100
	local objs={}
	local start_time=game_time
	local target_time=game_time+arrival_time
	for i,v in ipairs(message_points) do
		local t=target_time-game_time
		local spin=3
		local speed=4
		local rpt={(SyncedRandom()-0.5)*150, (SyncedRandom()-0.5)*150,(SyncedRandom()-0.5)*200}
		local target={v[1], v[2], target_height}
		local scale_pos=0.75
		local pos={rpt[1]*scale_pos, rpt[2], -SyncedRandom()*150}
		local vel={(target[1]-pos[1])/t, (target[2]-pos[2])/t, (target[3]-pos[3])/t}
		objs[i]={
			vel=vel,
			id=NewGameObject{
				type="Snowflake",
				pos=pos,
				vel=vel,
				angular_vel={(SyncedRandom()-0.5)*spin,(SyncedRandom()-0.5)*spin,(SyncedRandom()-0.5)*spin},
				speed_factor=50,
				radar_visible=false,
				radius=0.2,
				start_time=SyncedRandom()*1000,
				collision_radius=0
			}
		}
		Sleep(SyncedRandom()*0.1)
	end
	while game_time<start_time+95 do
		Sleep()
	end
	for i,v in ipairs(objs) do
		SetObjectState(v.id, {vel=ScaleVec(v.vel,0.25)})
	end
	while game_time<start_time+115 do
		Sleep()
	end
	for i,v in ipairs(objs) do
	SetObjectState(v.id, {vel={0,0,0}})
	end

end

function Script:SpawnBots()
end
