#version 120

// (C) Dmytry Lavrov. All rights reserved.

uniform vec3 brightness;
uniform vec3 stripe_brightness;

uniform mat4 stripe_matrix;
uniform mat4 stripe_matrix_2;

uniform sampler2D music_texture;
uniform float music_offset;
uniform float track_pos;
uniform float distort_scale;

void main(void)
{
   //vec4 camera_pos = gl_ModelViewMatrixInverse[3];

   //vec3 delta=gl_Vertex.xyz-camera_pos.xyz;
	vec3 delta=(gl_ModelViewMatrix*gl_Vertex).xyz;

	float l=dot(delta,delta);

	float q=exp2(255.0*gl_Color.a-119.0);

	vec3 col=gl_Color.rgb*(q/l);

	vec3 stripe_pos=(stripe_matrix*gl_Vertex).xyz;
	float r=length(stripe_pos);

	vec3 stripe_color=texture2DLod(music_texture, vec2(track_pos,music_offset-r), 0.0).rgb;
	stripe_color=abs(stripe_color);
	vec3 offset=stripe_color;

	col*=(stripe_color*stripe_brightness + vec3(1.0));

	gl_Position = gl_ModelViewProjectionMatrix * (gl_Vertex+vec4(distort_scale*offset,0));
	gl_FrontColor=vec4(brightness*col, 1.0);
}
